<?php
namespace Teknisa\SM\Factory;
use Doctrine\ORM\EntityManager;

class SmRelatorioContratoDataSourceFactory {
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * Busca os dados para a tela sem ou com filtro
     */
    public function find(array $params, $page, array $filtros) {
        $sql = "SELECT * FROM (
                    SELECT ROWNUM AS IND, BASE.*
                    FROM (SELECT DISTINCT CONT.NRSEQCONTRATO,
                              CONT.IDTPCONTRATO,
                              CONT.IDATIVO,
                              CONT.NRORG,
                              CONT.NRCONTRATOFCT,
                              TO_CHAR(NVL(CONT.DTINIVIGENCONT, CONT.DTINICIOCONTRATO), 'DD/MM/YYYY') AS DTINICONTRATO,
                              TO_CHAR(NVL(CONT.DTFINVIGENCONT, CONT.DTFIMCONTRATO), 'DD/MM/YYYY')    AS DTFINCONTRATO,
                              CONT.NRVERSAOCONTRATO,
                              CONT.CDFILIALORCA,
                              FILIAL.NMFILIAL,
                              CONT.NRSEQMODCONTRA,
                              FCT_MODELOCONTRATO.NMMODCONTRATO,
                              CONT.NRPARCNEGOCIO,
                              PARCNEGOCIO.NMPRINCIPALPARC,
                              CONT.DSREFERENCIACONT,
                              TO_CHAR(CONT.DTINICIOCONTRATO, 'DD/MM/YYYY') AS DTINICIOCONTRATO,
                              TO_CHAR(CONT.DTFIMCONTRATO, 'DD/MM/YYYY')    AS DTFIMCONTRATO,
                              CONT.NRDIASPRAZOCONT,
                              DECODE(CONT.DTINIVIGENCONT, NULL, CONT.NRDIASPRAZOCONT, CONT.NRDIASPRORGCONT) AS NRDIASPRORGCONT,
                              TO_CHAR(CONT.DTRECISAOCONTR, 'DD/MM/YYYY') AS DTRECISAOCONTR,
                              CONT.IDSITUACAOCONTRATO,
                              CONT.DSOBSERVACAOCONT,
                              CONT.NRSEQCONTRATOPAI,
                              CONT.CDSEQCONTRATO,
                              TO_CHAR(NVL(CONT.DTINIVIGENCONT, CONT.DTINICIOCONTRATO), 'DD/MM/YYYY') AS DTINIVIGENCONT,
                              TO_CHAR(NVL(CONT.DTFINVIGENCONT, CONT.DTFIMCONTRATO), 'DD/MM/YYYY')    AS DTFINVIGENCONT,
                              CONT.CDCENTCUST,
                              CENTCUST.NMCENTCUST,
                              CONT.NRPARCINTERLOCUTOR,
                              FCT_REFEORCACONT.IDGERADOPOR,
                              DECODE(FCT_REFEORCACONT.IDGERADOPOR, 'PROPOSTA', FCT_ORCAMENTO.NRORCAMENTO, NULL) AS NRORCAMENTO,
                              FCT_REFEORCACONT.NRSEQORCAMENTO,
                              MODELO.IDUTILIZACOMP,
                              CONT.QTPARCELASFATU,
                              CONT.NRDIAVENCPARCELASFATU,
                              CONT.CDOPERRESPONSAVEL,
                              OPER.NMOPERADOR AS NMOPERRESP,
                              TOTCONT.VRTOTALCONT,
                              CONT.DSJUSTIFCANCRENEG,
                              CONT.DSJUSTIFICAENCERRA,
                              FCT_ORCAMENTO.NRORCAMENTOMODELO,
                              FCT_REFEORCACONT.NRTIPOORCAMENTO,
                              NVL(FCT_TIPOORCAMENTO.IDUTILIZAVARPRECO, 'N') AS IDUTILIZAVARPRECO,
                              (SELECT COUNT(*)
                                FROM FCT_TRABSERVCONTRATO
                                WHERE NRSEQCONTRATO = CONT.NRSEQCONTRATO
                                AND NRORG           = CONT.NRORG) AS QTITENSTRABSERV
                            FROM FCT_CONTRATO CONT
                            LEFT JOIN (SELECT SUM(VRTOTITEMCOMDESC) AS VRTOTALCONT,
                                          NRSEQCONTRATO,
                                          NRORG
                                       FROM FCT_NEGOCIACAOCONTRATO
                                       GROUP BY NRSEQCONTRATO, NRORG) TOTCONT
                              ON CONT.NRSEQCONTRATO = TOTCONT.NRSEQCONTRATO
                              AND CONT.NRORG        = TOTCONT.NRORG
                            LEFT JOIN (SELECT * 
                                       FROM CRM_HIERARQUIAOPER 
                                       WHERE CDOPERADOR = :CDOPERADORLOGADO) HIERARPAI
                              ON CONT.NRORG = HIERARPAI.NRORG
                            LEFT JOIN CRM_HIERARQUIAOPER HIERAR
                              ON CONT.CDOPERRESPONSAVEL = HIERAR.CDOPERADOR
                              AND CONT.NRORG            = HIERAR.NRORG
                            LEFT JOIN FCT_PARAMETROGERAL PARAM
                              ON PARAM.NRORG = CONT.NRORG
                            LEFT JOIN OPERADOR OPER
                              ON CONT.CDOPERRESPONSAVEL = OPER.CDOPERADOR
                              AND CONT.NRORG            = OPER.NRORG
                            LEFT JOIN FILIAL
                              ON CONT.CDFILIALORCA = FILIAL.CDFILIAL
                              AND CONT.NRORG       = FILIAL.NRORG
                            LEFT JOIN FCT_MODELOCONTRATO
                              ON CONT.NRSEQMODCONTRA = FCT_MODELOCONTRATO.NRSEQMODCONTRA
                              AND CONT.NRORG         = FCT_MODELOCONTRATO.NRORG
                            LEFT JOIN PARCNEGOCIO
                              ON CONT.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
                              AND CONT.NRORG        = PARCNEGOCIO.NRORG
                            LEFT JOIN CENTCUST
                              ON CONT.CDCENTCUST = CENTCUST.CDCENTCUST
                              AND CONT.NRORG     = CENTCUST.NRORG
                            LEFT JOIN FCT_REFEORCACONT
                              ON CONT.NRSEQCONTRATO = FCT_REFEORCACONT.NRSEQCONTRATO
                              AND CONT.NRORG        = FCT_REFEORCACONT.NRORG
                            LEFT JOIN FCT_ORCAMENTO
                              ON FCT_REFEORCACONT.NRSEQORCAMENTO = FCT_ORCAMENTO.NRSEQORCAMENTO
                              AND FCT_REFEORCACONT.NRORG         = FCT_ORCAMENTO.NRORG
                            LEFT JOIN FCT_ORCAMENTOMODELO MODELO
                              ON FCT_ORCAMENTO.NRORCAMENTOMODELO = MODELO.NRORCAMENTOMODELO
                              AND FCT_ORCAMENTO.NRORG            = MODELO.NRORG
                            LEFT JOIN OPERADOR OPINC
                              ON CONT.CDOPERINCLUSAO = OPINC.CDOPERADOR
                              AND CONT.NRORG         = OPINC.NRORG
                            LEFT JOIN OPERADOR OPATU
                              ON CONT.CDOPERULTATU = OPATU.CDOPERADOR
                              AND CONT.NRORG       = OPATU.NRORG
                            LEFT JOIN FCT_TIPOORCAMENTO
                              ON FCT_REFEORCACONT.NRTIPOORCAMENTO     = FCT_TIPOORCAMENTO.NRTIPOORCAMENTO
                              AND FCT_REFEORCACONT.NRORG              = FCT_TIPOORCAMENTO.NRORG
                            LEFT JOIN FCT_TRABSERVCONTRATO TRAB
                                ON CONT.NRSEQCONTRATO = TRAB.NRSEQCONTRATO
                                AND CONT.NRORG        = TRAB.NRORG
                                AND TRAB.IDATIVO      = 'S'
                                AND TRAB.IDESCOLHIDO  = 'S'
                            LEFT JOIN FCT_RELACMEDIDACONTRATO MEDIDA
                                ON CONT.NRSEQCONTRATO = MEDIDA.NRSEQCONTRATO
                                AND CONT.NRORG        = MEDIDA.NRORG
                            LEFT JOIN FCT_ITEMCONTRATO ITEM
                                ON CONT.NRSEQCONTRATO = ITEM.NRSEQCONTRATO
                                AND CONT.NRORG        = ITEM.NRORG
                            WHERE CONT.NRORG = :NRORG
                                AND ((PARAM.IDUTILIZAHIEROPER  = 'N')
                                OR (PARAM.IDUTILIZAHIEROPER      = 'S'
                                    AND (((CONT.CDFILIALORCA = HIERARPAI.CDFILIAL OR CONT.CDFILIALORCA IS NULL)
                                           AND (CONT.CDOPERRESPONSAVEL IN (SELECT CDOPERADOR
                                                                               FROM FCT_HIERARQUIAOPER
                                                                               WHERE (FCT_HIERARQUIAOPER.CDFILIAL   = HIERARPAI.CDFILIAL
                                                                                    OR FCT_HIERARQUIAOPER.CDFILIAL IS NULL )
                                                                               CONNECT BY PRIOR FCT_HIERARQUIAOPER.NRHIERARQUIAOPER = FCT_HIERARQUIAOPER.NRHIERARQUIAPAI
                                                                               START WITH FCT_HIERARQUIAOPER.CDOPERADOR             = HIERARPAI.CDOPERADOR))
                                OR CONT.CDOPERRESPONSAVEL IS NULL
                                OR CONT.CDOPERRESPONSAVEL  = :CDOPERADORLOGADO)
                                OR (HIERARPAI.IDOPERMASTER     = 'S'))))";
        
        if(count($filtros) > 0) {  
            // FieldGroup Dados do Contrato
            if(array_key_exists("NRSEQCONTRATO", $filtros))
                $sql .= " AND CONT.NRSEQCONTRATO IN(". $filtros["NRSEQCONTRATO"] . ")";
            
            if(array_key_exists("IDATIVO", $filtros))
                $sql .= " AND CONT.IDATIVO IN('". $filtros["IDATIVO"] . "')";
                
            if(array_key_exists("NRPARCNEGOCIO", $filtros))
                $sql .= " AND CONT.NRPARCNEGOCIO IN(". $filtros["NRPARCNEGOCIO"]. ")";
            
            if(array_key_exists("NRVERSAOCONTRATO", $filtros))
                $sql .= " AND CONT.NRVERSAOCONTRATO IN(". $filtros["NRVERSAOCONTRATO"]. ")";
            
            if(array_key_exists("IDSITUACAOCONTRATO", $filtros))
                $sql .= " AND CONT.IDSITUACAOCONTRATO IN('". $filtros["IDSITUACAOCONTRATO"]. "')";
            
            if(array_key_exists("CDFILIALORCA", $filtros))
                $sql .= " AND CONT.CDFILIALORCA IN('". $filtros["CDFILIALORCA"]. "')";
            
            if(array_key_exists("CDCENTCUST", $filtros))
                $sql .= " AND CONT.CDCENTCUST IN('". $filtros["CDCENTCUST"]. "')";
            
            if(array_key_exists("NRSEQMODCONTRA", $filtros))
                $sql .= " AND CONT.NRSEQMODCONTRA IN(". $filtros["NRSEQMODCONTRA"]. ")";
                
            if(array_key_exists("CDOPERRESPONSAVEL", $filtros))
                $sql .= " AND CONT.CDOPERRESPONSAVEL IN('". $filtros["CDOPERRESPONSAVEL"]. "')";

            // FieldGroup Validade        
            if(array_key_exists("DTINICIOCONTRATO", $filtros))
                $sql .= " AND CONT.DTINICIOCONTRATO BETWEEN TO_DATE('". $filtros["DTINICIOCONTRATO"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTINICIOCONTRATO"][1] . "', 'DD/MM/YYYY')";
                
            if(array_key_exists("DTFIMCONTRATO", $filtros))
                $sql .= " AND CONT.DTFIMCONTRATO BETWEEN TO_DATE('". $filtros["DTFIMCONTRATO"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTFIMCONTRATO"][1] . "', 'DD/MM/YYYY')";
                
            if(array_key_exists("DTINICONTRATO", $filtros))
                $sql .= " AND CONT.DTINIVIGENCONT BETWEEN TO_DATE('". $filtros["DTINICONTRATO"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTINICONTRATO"][1] . "', 'DD/MM/YYYY')";
                
            if(array_key_exists("DTFINCONTRATO", $filtros))
                $sql .= " AND CONT.DTFINVIGENCONT BETWEEN TO_DATE('". $filtros["DTFINCONTRATO"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTFINCONTRATO"][1] . "', 'DD/MM/YYYY')";
            
            // FieldGroup Proposta
            if(array_key_exists("NRSEQORCAMENTO", $filtros))
                $sql .= " AND FCT_ORCAMENTO.NRSEQORCAMENTO IN(". $filtros["NRSEQORCAMENTO"] . ")";
                
            if(array_key_exists("NRORCAMENTOMODELO", $filtros))
                $sql .= " AND MODELO.NRORCAMENTOMODELO IN(". $filtros["NRORCAMENTOMODELO"]. ")";
            
            if(array_key_exists("NRTIPOORCAMENTO", $filtros))
                $sql .= " AND FCT_TIPOORCAMENTO.NRTIPOORCAMENTO IN(". $filtros["NRTIPOORCAMENTO"]. ")";
            
            // FieldGroup Serviço
            if(array_key_exists("IDELEMENTO", $filtros))
                $sql .= " AND TRAB.IDELEMENTO IN('". $filtros["IDELEMENTO"]. "')";
            
            if(array_key_exists("CDSERVORCA", $filtros))
                $sql .= " AND ITEM.CDSERVORCA IN(". $filtros["CDSERVORCA"]. ")";
            
            if(array_key_exists("CDTPMEDIDASERV", $filtros))
                $sql .= " AND (MEDIDA.CDTPMEDIDAVARIAVEL IN(". $filtros["CDTPMEDIDASERV"] . ") OR ITEM.CDTPMEDIDASERV IN(". $filtros["CDTPMEDIDASERV"] . "))";    
            
            // FieldGroup Recisão
            if(array_key_exists("DTRECISAOCONTR", $filtros))
                $sql .= " AND CONT.DTRECISAOCONTR BETWEEN TO_DATE('". $filtros["DTRECISAOCONTR"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTRECISAOCONTR"][1] . "', 'DD/MM/YYYY')";
        }
        
        $sql .= " ORDER BY CONT.NRSEQCONTRATO DESC) BASE ) TBL ";
        if ($page != null){
            $sql .= " WHERE (IND > " . (($page - 1) * 50) . " AND IND <= " . $page * 50 . ")";
        }
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    /**
     * Busca os dados para a tela sem ou com filtro
     */
    public function findItens(array $params, array $filtros) {
        $sql = "SELECT DISTINCT 
                    CONT.NRSEQCONTRATO,
                    DECODE(ITEM.IDELEMENTO, NULL, CONT.NRCONTRATOFCT, NULL) AS NRCONTRATOFCT,
                    ITEM.NRITEMOCONTRATO,
                    ITEM.NRITEMCONTRATOPAI,
                    ITEM.NMITEMCONTRATO,
                    DECODE(ITEM.IDELEMENTO, NULL, NULL, DECODE(NVL(ITEM.QTMEDIDACONTR, 0), 0, '0,00', TO_CHAR(ITEM.QTMEDIDACONTR, 'FM999G999G999D90', 'nls_numeric_characters='',.'''))) AS QTMEDIDAORCA,
                    ITEM.VRTOTITEMCONT,
                    DECODE(ITEM.IDELEMENTO, NULL, NULL, ITEMMED.DSTPMEDIDASERV) AS DSTPMEDIDASERV
                FROM FCT_CONTRATO CONT
                LEFT JOIN (SELECT SUM(VRTOTITEMCOMDESC) AS VRTOTALCONT,
                              NRSEQCONTRATO,
                              NRORG
                           FROM FCT_NEGOCIACAOCONTRATO
                           GROUP BY NRSEQCONTRATO, NRORG) TOTCONT
                  ON CONT.NRSEQCONTRATO = TOTCONT.NRSEQCONTRATO
                  AND CONT.NRORG        = TOTCONT.NRORG
                LEFT JOIN (SELECT * 
                           FROM CRM_HIERARQUIAOPER 
                           WHERE CDOPERADOR = :CDOPERADORLOGADO) HIERARPAI
                  ON CONT.NRORG = HIERARPAI.NRORG
                LEFT JOIN CRM_HIERARQUIAOPER HIERAR
                  ON CONT.CDOPERRESPONSAVEL = HIERAR.CDOPERADOR
                  AND CONT.NRORG            = HIERAR.NRORG
                LEFT JOIN FCT_PARAMETROGERAL PARAM
                  ON PARAM.NRORG = CONT.NRORG
                LEFT JOIN OPERADOR OPER
                  ON CONT.CDOPERRESPONSAVEL = OPER.CDOPERADOR
                  AND CONT.NRORG            = OPER.NRORG
                LEFT JOIN FILIAL
                  ON CONT.CDFILIALORCA = FILIAL.CDFILIAL
                  AND CONT.NRORG       = FILIAL.NRORG
                LEFT JOIN FCT_MODELOCONTRATO
                  ON CONT.NRSEQMODCONTRA = FCT_MODELOCONTRATO.NRSEQMODCONTRA
                  AND CONT.NRORG         = FCT_MODELOCONTRATO.NRORG
                LEFT JOIN PARCNEGOCIO
                  ON CONT.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
                  AND CONT.NRORG        = PARCNEGOCIO.NRORG
                LEFT JOIN CENTCUST
                  ON CONT.CDCENTCUST = CENTCUST.CDCENTCUST
                  AND CONT.NRORG     = CENTCUST.NRORG
                LEFT JOIN FCT_REFEORCACONT
                  ON CONT.NRSEQCONTRATO = FCT_REFEORCACONT.NRSEQCONTRATO
                  AND CONT.NRORG        = FCT_REFEORCACONT.NRORG
                LEFT JOIN FCT_ORCAMENTO
                  ON FCT_REFEORCACONT.NRSEQORCAMENTO = FCT_ORCAMENTO.NRSEQORCAMENTO
                  AND FCT_REFEORCACONT.NRORG         = FCT_ORCAMENTO.NRORG
                LEFT JOIN FCT_ORCAMENTOMODELO MODELO
                  ON FCT_ORCAMENTO.NRORCAMENTOMODELO = MODELO.NRORCAMENTOMODELO
                  AND FCT_ORCAMENTO.NRORG            = MODELO.NRORG
                LEFT JOIN OPERADOR OPINC
                  ON CONT.CDOPERINCLUSAO = OPINC.CDOPERADOR
                  AND CONT.NRORG         = OPINC.NRORG
                LEFT JOIN OPERADOR OPATU
                  ON CONT.CDOPERULTATU = OPATU.CDOPERADOR
                  AND CONT.NRORG       = OPATU.NRORG
                LEFT JOIN FCT_TIPOORCAMENTO
                  ON FCT_REFEORCACONT.NRTIPOORCAMENTO     = FCT_TIPOORCAMENTO.NRTIPOORCAMENTO
                  AND FCT_REFEORCACONT.NRORG              = FCT_TIPOORCAMENTO.NRORG
                LEFT JOIN FCT_TRABSERVCONTRATO TRAB
                    ON CONT.NRSEQCONTRATO = TRAB.NRSEQCONTRATO
                    AND CONT.NRORG        = TRAB.NRORG
                    AND TRAB.IDATIVO      = 'S'
                    AND TRAB.IDESCOLHIDO  = 'S'
                LEFT JOIN FCT_RELACMEDIDACONTRATO MEDIDA
                    ON CONT.NRSEQCONTRATO = MEDIDA.NRSEQCONTRATO
                    AND CONT.NRORG        = MEDIDA.NRORG
                LEFT JOIN FCT_ITEMCONTRATO ITEM
                    ON CONT.NRSEQCONTRATO = ITEM.NRSEQCONTRATO
                    AND CONT.NRORG        = ITEM.NRORG
                LEFT JOIN FCT_TIPOMEDIDASERV ITEMMED
                    ON ITEM.CDTPMEDIDAVARIAVEL = ITEMMED.CDTPMEDIDASERV
                    AND ITEM.NRORG             = ITEMMED.NRORG
                WHERE CONT.NRORG = :NRORG
                    AND ((PARAM.IDUTILIZAHIEROPER  = 'N')
                    OR (PARAM.IDUTILIZAHIEROPER      = 'S'
                        AND (((CONT.CDFILIALORCA = HIERARPAI.CDFILIAL OR CONT.CDFILIALORCA IS NULL)
                               AND (CONT.CDOPERRESPONSAVEL IN (SELECT CDOPERADOR
                                                                   FROM FCT_HIERARQUIAOPER
                                                                   WHERE (FCT_HIERARQUIAOPER.CDFILIAL   = HIERARPAI.CDFILIAL
                                                                        OR FCT_HIERARQUIAOPER.CDFILIAL IS NULL )
                                                                   CONNECT BY PRIOR FCT_HIERARQUIAOPER.NRHIERARQUIAOPER = FCT_HIERARQUIAOPER.NRHIERARQUIAPAI
                                                                   START WITH FCT_HIERARQUIAOPER.CDOPERADOR             = HIERARPAI.CDOPERADOR))
                    OR CONT.CDOPERRESPONSAVEL IS NULL
                    OR CONT.CDOPERRESPONSAVEL  = :CDOPERADORLOGADO)
                    OR (HIERARPAI.IDOPERMASTER     = 'S'))))";
        
        if(count($filtros) > 0) {  
            // FieldGroup Dados do Contrato
            if(array_key_exists("NRSEQCONTRATO", $filtros))
                $sql .= " AND CONT.NRSEQCONTRATO IN(". $filtros["NRSEQCONTRATO"] . ")";
            
            if(array_key_exists("IDATIVO", $filtros))
                $sql .= " AND CONT.IDATIVO IN('". $filtros["IDATIVO"] . "')";
                
            if(array_key_exists("NRPARCNEGOCIO", $filtros))
                $sql .= " AND CONT.NRPARCNEGOCIO IN(". $filtros["NRPARCNEGOCIO"]. ")";
            
            if(array_key_exists("NRVERSAOCONTRATO", $filtros))
                $sql .= " AND CONT.NRVERSAOCONTRATO IN(". $filtros["NRVERSAOCONTRATO"]. ")";
            
            if(array_key_exists("IDSITUACAOCONTRATO", $filtros))
                $sql .= " AND CONT.IDSITUACAOCONTRATO IN('". $filtros["IDSITUACAOCONTRATO"]. "')";
            
            if(array_key_exists("CDFILIALORCA", $filtros))
                $sql .= " AND CONT.CDFILIALORCA IN('". $filtros["CDFILIALORCA"]. "')";
            
            if(array_key_exists("CDCENTCUST", $filtros))
                $sql .= " AND CONT.CDCENTCUST IN('". $filtros["CDCENTCUST"]. "')";
            
            if(array_key_exists("NRSEQMODCONTRA", $filtros))
                $sql .= " AND CONT.NRSEQMODCONTRA IN(". $filtros["NRSEQMODCONTRA"]. ")";
                
            if(array_key_exists("CDOPERRESPONSAVEL", $filtros))
                $sql .= " AND CONT.CDOPERRESPONSAVEL IN('". $filtros["CDOPERRESPONSAVEL"]. "')";

            // FieldGroup Validade        
            if(array_key_exists("DTINICIOCONTRATO", $filtros))
                $sql .= " AND CONT.DTINICIOCONTRATO BETWEEN TO_DATE('". $filtros["DTINICIOCONTRATO"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTINICIOCONTRATO"][1] . "', 'DD/MM/YYYY')";
                
            if(array_key_exists("DTFIMCONTRATO", $filtros))
                $sql .= " AND CONT.DTFIMCONTRATO BETWEEN TO_DATE('". $filtros["DTFIMCONTRATO"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTFIMCONTRATO"][1] . "', 'DD/MM/YYYY')";
                
            if(array_key_exists("DTINICONTRATO", $filtros))
                $sql .= " AND CONT.DTINIVIGENCONT BETWEEN TO_DATE('". $filtros["DTINICONTRATO"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTINICONTRATO"][1] . "', 'DD/MM/YYYY')";
                
            if(array_key_exists("DTFINCONTRATO", $filtros))
                $sql .= " AND CONT.DTFINVIGENCONT BETWEEN TO_DATE('". $filtros["DTFINCONTRATO"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTFINCONTRATO"][1] . "', 'DD/MM/YYYY')";
            
            // FieldGroup Proposta
            if(array_key_exists("NRSEQORCAMENTO", $filtros))
                $sql .= " AND FCT_ORCAMENTO.NRSEQORCAMENTO IN(". $filtros["NRSEQORCAMENTO"] . ")";
                
            if(array_key_exists("NRORCAMENTOMODELO", $filtros))
                $sql .= " AND MODELO.NRORCAMENTOMODELO IN(". $filtros["NRORCAMENTOMODELO"]. ")";
            
            if(array_key_exists("NRTIPOORCAMENTO", $filtros))
                $sql .= " AND FCT_TIPOORCAMENTO.NRTIPOORCAMENTO IN(". $filtros["NRTIPOORCAMENTO"]. ")";
            
            // FieldGroup Serviço
            if(array_key_exists("IDELEMENTO", $filtros))
                $sql .= " AND TRAB.IDELEMENTO IN('". $filtros["IDELEMENTO"]. "')";
            
            if(array_key_exists("CDSERVORCA", $filtros))
                $sql .= " AND ITEM.CDSERVORCA IN(". $filtros["CDSERVORCA"]. ")";
            
            if(array_key_exists("CDTPMEDIDASERV", $filtros))
                $sql .= " AND (MEDIDA.CDTPMEDIDAVARIAVEL IN(". $filtros["CDTPMEDIDASERV"] . ") OR ITEM.CDTPMEDIDASERV IN(". $filtros["CDTPMEDIDASERV"] . "))";    
            
            // FieldGroup Recisão
            if(array_key_exists("DTRECISAOCONTR", $filtros))
                $sql .= " AND CONT.DTRECISAOCONTR BETWEEN TO_DATE('". $filtros["DTRECISAOCONTR"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTRECISAOCONTR"][1] . "', 'DD/MM/YYYY')";
        }
        
        $sql .= " ORDER BY CONT.NRSEQCONTRATO DESC ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}
?>