/* Sistemas Integrados TEKNISA

Nome: 7822_PLASTPO - EXPORTA_EXC_CONSUMO.SQL

Descrio:
Procedimento para exportao de exceo no consumo das filial agregadas do Sistema PME

Criao:
30/04/2007 - Felipe Amaral Gurgel
*/
CREATE OR REPLACE PROCEDURE EXPORTA_EXC_CONSUMO(
   P_NRLISTAFILISERV    IN VARCHAR2,
   P_DTCONSSERVINIGRAVA IN DATE,
   P_DTCONSSERVFINGRAVA IN DATE,
   P_CDFILIORIG         IN VARCHAR2,
   P_CDSERVORIG         IN VARCHAR2,
   P_IDQTDECONS         IN VARCHAR2,
   P_IDTIPOCONS         IN VARCHAR2,
   P_DTCONSSERVORIG     IN DATE,
   P_CDPRODUTO          IN VARCHAR2,
   P_IDSOBREPOR         IN VARCHAR2,
   P_CDFILICENTGRAVA    IN VARCHAR2,
   P_CDFILICENTORIG     IN VARCHAR2,
   P_CDFILCENTPME       IN VARCHAR2,
   P_NRLISTAPROD        IN VARCHAR2)    
IS
   V_DTGRAVA     DATE; 
   V_DIASEMANA   VARCHAR(4);
   V_SEMANAGRAVA VARCHAR(15); 
BEGIN
   V_DTGRAVA := P_DTCONSSERVINIGRAVA;
   V_SEMANAGRAVA := P_IDTIPOCONS;
      
   WHILE V_DTGRAVA <= P_DTCONSSERVFINGRAVA LOOP   
      SELECT TO_CHAR(V_DTGRAVA,'D')    /*GRAVA O NMERO DO DIA DA SEMANA*/
        INTO V_DIASEMANA
        FROM DUAL;
      SELECT INSTR(P_IDTIPOCONS, V_DIASEMANA)   /*CONFERE O DIA DA SEMANA MARCADO PARA GRAVAR*/
        INTO V_SEMANAGRAVA
       FROM DUAL; 
      IF V_SEMANAGRAVA = V_DIASEMANA THEN     
         IF P_IDSOBREPOR = 'S' THEN
            DELETE
              FROM CONSSERVPME
             WHERE CDFILCENTPME = P_CDFILCENTPME 
               AND CDFILIAL||CDSERVFILI IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = P_NRLISTAFILISERV)
               AND IDQTDECONPME = P_IDQTDECONS 
               AND IDTIPOCONPME = '9' 
               AND DTCONSERVPME = V_DTGRAVA
               AND CDFILCENTPME||CDFILIAL||CDSERVFILI||DTCONSERVPME NOT IN (SELECT DISTINCT CDFILCENTPME||LISTA.CDLISTA||DTCONSERVPME
                                                                              FROM CONSSERVPME, LISTA
                                                                             WHERE CDFILCENTPME = P_CDFILICENTORIG
                                                                               AND CDFILIAL||CDSERVFILI = LISTA.CDLISTA
                                                                               AND P_CDFILIORIG||P_CDSERVORIG = LISTA.CDLISTA
                                                                               AND IDQTDECONPME = P_IDQTDECONS        
                                                                               AND IDTIPOCONPME = '9'
                                                                               AND DTCONSERVPME = P_DTCONSSERVORIG
                                                                               AND LISTA.NRLISTA = P_NRLISTAFILISERV);
         END IF;    
         
         FOR C_DIASEMCONSUMO IN (SELECT DIASEMCONSPME.CDFILCENTPME, CDFILIAL, CDSERVFILI, DIASEMCONSPME.DTSEMCONSPME,
                                        DIASEMCONSPME.IDTPCONSPME, DIASEMCONSPME.DTULTATUDIAS
                                   FROM DIASEMCONSPME, LISTA
                                  WHERE CDFILCENTPME = P_CDFILCENTPME
                                    AND CDFILIAL||CDSERVFILI = LISTA.CDLISTA
     	                            AND CDFILIAL||CDSERVFILI IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = P_NRLISTAFILISERV)     
                                    AND DTSEMCONSPME = V_DTGRAVA) LOOP
            IF C_DIASEMCONSUMO.IDTPCONSPME = 'A' THEN 
               IF P_IDQTDECONS = 'F' THEN     /* UPDATA DIASEMCONSPME PARA 'P'*/
                  UPDATE DIASEMCONSPME         
                     SET IDTPCONSPME = 'P'    
                   WHERE CDFILCENTPME = P_CDFILICENTGRAVA 
                     AND CDFILIAL||CDSERVFILI IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = P_NRLISTAFILISERV)
                     AND DTSEMCONSPME = V_DTGRAVA
                     AND IDTPCONSPME = 'A';     
               ELSE                           /* UPDATA DIASEMCONS PARA 'F'*/  
                  UPDATE DIASEMCONSPME         
                     SET IDTPCONSPME = 'F'    
                   WHERE CDFILCENTPME = P_CDFILICENTGRAVA 
                     AND CDFILIAL||CDSERVFILI IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = P_NRLISTAFILISERV)
                     AND DTSEMCONSPME = V_DTGRAVA
                     AND IDTPCONSPME = 'A';             
               END IF;        
            END IF;  
            IF C_DIASEMCONSUMO.IDTPCONSPME = P_IDQTDECONS THEN     /* DELETA DIASEMCONS = P_IDQTDECONS*/
               DELETE 
                 FROM DIASEMCONSPME
                WHERE CDFILCENTPME = P_CDFILICENTGRAVA
                  AND CDFILIAL||CDSERVFILI IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = P_NRLISTAFILISERV)  
                  AND DTSEMCONSPME = V_DTGRAVA;
            END IF; 
         END LOOP;                                 
         INSERT INTO CONSSERVPME
                (CDFILCENTPME, CDFILIAL, CDSERVFILI, IDQTDECONPME,
                 IDTIPOCONPME, DTCONSERVPME, CDPRODUTO, QTCONSERVPME)
                (SELECT P_CDFILICENTGRAVA, SUBSTR(LF.CDLISTA, 1, 4), SUBSTR(LF.CDLISTA, 5, 9),
                        A.IDQTDECONPME, A.IDTIPOCONPME, V_DTGRAVA, A.CDPRODUTO, A.QTCONSERVPME
                   FROM CONSSERVPME A, LISTA LP, LISTA LF
                  WHERE (A.CDFILCENTPME = P_CDFILICENTORIG)  
                    AND (A.CDFILIAL     = P_CDFILIORIG)     
                    AND (A.CDSERVFILI   = P_CDSERVORIG)     
                    AND (A.IDQTDECONPME = P_IDQTDECONS)     
                    AND (A.IDTIPOCONPME = '9')     
                    AND (A.DTCONSERVPME = P_DTCONSSERVORIG) 
                    AND (LF.NRLISTA     = P_NRLISTAFILISERV)
                    AND (LP.NRLISTA     = P_NRLISTAPROD)        
                    AND (LP.CDLISTA     = A.CDPRODUTO)       
                    AND (LF.CDLISTA||LP.CDLISTA NOT IN (SELECT CDFILIAL||CDSERVFILI||CDPRODUTO
                                                          FROM CONSSERVPME B, LISTA L
                                                         WHERE B.CDFILCENTPME = P_CDFILICENTGRAVA 
                                                           AND B.CDFILIAL||B.CDSERVFILI 
                                                            IN (SELECT CDLISTA FROM LISTA WHERE NRLISTA = P_NRLISTAFILISERV)
                                                           AND B.IDQTDECONPME = P_IDQTDECONS      
                                                           AND B.IDTIPOCONPME = '9'      
                                                           AND B.DTCONSERVPME = V_DTGRAVA
                                                           AND B.CDPRODUTO  = A.CDPRODUTO)));
      END IF; 
      V_DTGRAVA := V_DTGRAVA + 1;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_EXC_CONSUMO','5.03.007'); END;
/

